#!/usr/bin/perl -wT
# -------------------------------------------------------------------
# slash_amigos.cgi
# Copyright (C) 2005 by James A. Chappell (rlrr@amon-hen.com)
#
# slash_amigos.cgi is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as published
# by the Free Software Foundation; either version 2, or (at your option) any
# later version.
#
# slash_amigos.cgi is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with slash_amigos.cgi; see the file COPYING.  If not, write
# to the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139,
# USA.
# -------------------------------------------------------------------
#
# slash_amgigos: Version 0.1
# Created by James A. Chappell
# Created: 10 January 2005
# Last Modified: 10 January 2005
#
# -------------------------------------------------------------------
#
# This cgi script extracts links to a user's friends' Slashdot
# Journal entries and displays them on a web page.
#

use strict ;
use Fcntl ':flock' ; # import LOCK_* constants
use File::stat ;
use LWP::UserAgent;
use CGI;
#
# Modify slash_amigos.cgi as per the instructions in these comments.
#
#
# Replace my_username with your (or someone else's) slashdot username
#
my $username = "my_username" ;
#
# Replace "/home/myuid/mydir/slash_amigos.rss" with the full path
# to the file where the journal entries will be saved.  Make sure
# the directory has the appropriate write permissions
#
my $HEADLINE_FILE = "/home/myuid/mydir/slash_amigos.rss" ;
#
#--------------------------------------------------------------------
#
# No further modifications are required from here on
#
#--------------------------------------------------------------------
#

my $URL = "http://slashdot.org/~$username/journal/friends/rss" ;
my $REFRESH = 3600 ;

my $STORY_START = "<item " ;
my $STORY_END = "</item>" ;
my $TITLE_START = "<title>" ;
my $TITLE_END = "</title>" ;
my $URL_START = "<link>" ;
my $URL_END = "</link>" ;
my $TIME_START = "<dc:date>" ;
my $TIME_END = "</dc:date>" ;
my $AUTH_START = "<dc:creator>" ;
my $AUTH_END = "</dc:creator>" ;

my $q = new CGI ;

print $q->header("text/html");

my $st = 0 ;
if (-e "$HEADLINE_FILE")
{
    $st = stat($HEADLINE_FILE)  ;
}

my $update_flag = 0 ;
if (!$st)
{
    $update_flag = 1 ;
}
else
{
    my $time = time ;
    my $delta_time = $time - $st->mtime ;
    if ($delta_time >  $REFRESH)
    {
        $update_flag = 1 ;
    }
}

if ($update_flag)
{
    my $ua=new LWP::UserAgent;
    $ua->timeout(15) ;
    my $request=new HTTP::Request('GET', $URL);
    my $response=$ua->request($request);

    if ($response->is_success)
    {
        open(HL, ">$HEADLINE_FILE") || die "Cannot open $HEADLINE_FILE\n" ;
        flock(HL, LOCK_EX) ;
        seek(HL, 0, 2) ;

        print HL $response->content  ;

        close HL ;
    }
}

open(HL, "$HEADLINE_FILE") || die "Cannot open $HEADLINE_FILE\n" ;
flock(HL, LOCK_SH) ;

my $title ;
my $url ;
my $time ;
my $author ;

my $tmp ;

my $line ;

while ($line = <HL>)
{   
    $line =~ s/^\s*(.*?)\s*$/$1/;
    if ($line eq "</channel>")
    {
        last ;
    }
}

while ($line = <HL>)
{   
    $line =~ s/^\s*(.*?)\s*$/$1/;
    if (index($line, $TITLE_START) ge 0)
    {
        last ;
    }
}

print "<table>\n" ;
while ($line = <HL>)
{   
    $line =~ s/^\s*(.*?)\s*$/$1/;
    if (index($line, $STORY_START) ge 0)
    {
        while ($line = <HL>)
        {
            $line =~ s/^\s*(.*?)\s*$/$1/;
            if ($line eq $STORY_END)
            {
                $title =~ s/&amp;/&/g ;
                $title =~ s/&lt;/</g ;
                $title =~ s/&gt;/>/g ;

                print "<tr>\n" ;
                print "<td valign=\"top\">-</td><td valign=\"middle\">\n" ;
                print $q->a({ -href=>$url }, $title) ;
                print "</td><td valign=\"middle\"> $author" ;
                print "</td><td valign=\"middle\"> $time" ;
                print "</td>\n</tr>\n" ;
                last ;
            }
            else
            {
                if (index($line, $TITLE_START) ge 0)
                {
                    $title = $line ;
                    $title =~ s/$TITLE_START//g ; 
                    $title =~ s/$TITLE_END//g ; 
                }
                elsif (index($line, $URL_START) ge 0)
                {
                    $url = $line ;
                    $url =~ s/$URL_START//g ; 
                    $url =~ s/$URL_END//g ; 
                }
                elsif (index($line, $TIME_START) ge 0)
                {
                    $time = $line ;
                    $time =~ s/$TIME_START//g ; 
                    $time =~ s/$TIME_END//g ; 
                    
                    ($time, $tmp) = split('\+', $time) ;
                    ($time, $tmp) = split('T', $time) ;
                    $time = $time. ", ".$tmp ;
                }
                elsif (index($line, $AUTH_START) ge 0)
                {
                    $author = $line ;
                    $author =~ s/$AUTH_START//g ; 
                    $author =~ s/$AUTH_END//g ; 
                }
            }
        }
    }
}
print "</table>\n" ;

close HL ;
